{
  "openapi": "3.0.0",
  "info": {
    "title": "Flutterwave v3",
    "description": "The Flutterwave for Business(F4B) APIs collection for all v3 endpoints with pre-formatted requests and response examples.\n## Errors\nErrors return an envelope with `status: \"error\"`, a human-readable `message`, and `data: null`.\nCommon statuses: `400` validation, `401` authorization, `429` rate limit, `500` server error.\n\n## Rate limits\nRequest rates are limited per account (the account whose API key made the call).\nWhen exceeded, the API returns HTTP `429`; wait and retry, increasing the wait after each retry.",
    "version": "1.0.0"
  },
  "servers": [
    {
      "url": "https://api.flutterwave.com"
    }
  ],
  "components": {
    "securitySchemes": {
      "bearerAuth": {
        "type": "http",
        "scheme": "bearer"
      }
    }
  },
  "security": [
    {
      "bearerAuth": []
    }
  ],
  "tags": [
    {
      "name": "Charges",
      "description": "The charge APIs includes several payment collection methods to help you collect payments."
    },
    {
      "name": "Tokenized Charges",
      "description": "Tokenize your customers' cards with Flutterwave for faster payments"
    },
    {
      "name": "Preauthorization",
      "description": "Manage preauth attemps on card transactions"
    },
    {
      "name": "Transactions",
      "description": "Manage transactions, query statuses, logs and fees"
    },
    {
      "name": "Transfers",
      "description": "Transfers to local and international customers"
    },
    {
      "name": "Beneficiaries",
      "description": "Manage transfer beneficiaries"
    },
    {
      "name": "Virtual Cards",
      "description": "Manage Flutterwave virtual cards"
    },
    {
      "name": "Virtual Account Numbers",
      "description": "Manage virtual accounts"
    },
    {
      "name": "Collection Subaccounts",
      "description": "Manage Collection Subaccounts"
    },
    {
      "name": "Payout Subaccounts",
      "description": "Manage Payout Subaccounts"
    },
    {
      "name": "Subscriptions",
      "description": "Manage user subscriptions"
    },
    {
      "name": "Payment Plans",
      "description": "Manage Payment Plans"
    },
    {
      "name": "Bill Payments",
      "description": "Manage Bill Payments"
    },
    {
      "name": "Banks",
      "description": "Fetch Bank Information"
    },
    {
      "name": "Misc",
      "description": "Verify user information like bank verification numbers, card bins, account information"
    },
    {
      "name": "Settlements",
      "description": "Manage your settlements"
    },
    {
      "name": "Otps",
      "description": "Create and manage one time passwords (OTPs) for your applications"
    },
    {
      "name": "Chargebacks",
      "description": "Manage Chargebacks"
    }
  ],
  "paths": {
    "/v3/charges": {
      "post": {
        "tags": [
          "Preauthorization"
        ],
        "summary": "Initiate Preauth Charge",
        "description": "Initiate a preauth charge on a customer's card",
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "type": "object",
                "example": {
                  "tx_ref": "YOUR_UNIQUE_REFERENCE",
                  "amount": 100,
                  "currency": "NGN",
                  "card_number": "5377283645077450",
                  "expiry_month": "09",
                  "expiry_year": "31",
                  "cvv": "789",
                  "redirect_url": "https://www.google.com",
                  "email": "developers@flutterwavego.com",
                  "preauthorize": true
                }
              }
            }
          }
        },
        "parameters": [
          {
            "name": "type",
            "in": "query",
            "schema": {
              "type": "string"
            },
            "example": "card"
          }
        ],
        "responses": {
          "200": {
            "description": "Successful response",
            "content": {
              "application/json": {
                "example": {
                  "status": "success",
                  "message": "Successful",
                  "data": {
                    "id": 4973065,
                    "tx_ref": "YOUR_UNIQUE_REFERENCE",
                    "flw_ref": "FLW-MOCK-2477a2b9d7845b31976cd50c0af890f1",
                    "device_fingerprint": "N/A",
                    "amount": 100,
                    "charged_amount": 100,
                    "app_fee": 1.4,
                    "merchant_fee": 0,
                    "processor_response": "Please enter the OTP sent to your mobile number 080****** and email te**@rave**.com",
                    "auth_model": "NOAUTH",
                    "currency": "NGN",
                    "ip": "52.209.154.143",
                    "narration": "CARD Transaction ",
                    "status": "successful",
                    "auth_url": "https://ravesandboxapi.flutterwave.com/mockvbvpage?ref=FLW-MOCK-2477a2b9d7845b31976cd50c0af890f1&code=00&message=Approved.%20Successful&receiptno=RN1710749806478",
                    "payment_type": "card",
                    "plan": null,
                    "fraud_status": "ok",
                    "charge_type": "normal",
                    "created_at": "2024-03-18T08:16:46.000Z",
                    "account_id": 20937,
                    "customer": {
                      "id": 2373734,
                      "phone_number": null,
                      "name": "Anonymous customer",
                      "email": "developers@flutterwavego.com",
                      "created_at": "2024-03-18T08:16:46.000Z"
                    },
                    "card": {
                      "first_6digits": "553188",
                      "last_4digits": "2950",
                      "issuer": "MASTERCARD  CREDIT",
                      "country": "NG",
                      "type": "MASTERCARD",
                      "expiry": "09/32"
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "Validation error — a required parameter is missing or invalid.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "status": "error",
                  "message": "Cardno is required",
                  "data": null
                }
              }
            }
          },
          "401": {
            "description": "Authorization error — secret key missing or incorrect.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "status": "error",
                  "message": "Authorization required",
                  "data": null
                }
              }
            }
          },
          "429": {
            "description": "Rate limit exceeded — wait and retry, increasing the wait after each retry (exponential backoff).",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "status": "error",
                  "message": "Too many requests",
                  "data": null
                }
              }
            }
          },
          "500": {
            "description": "Server error — retry after a while or contact support with the error_id.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "error_id": "ERRNO796977608T1620310828419",
                  "message": "Application error. Please contact support",
                  "code": "app_error"
                }
              }
            }
          }
        }
      }
    },
    "/v3/validate-charge": {
      "post": {
        "tags": [
          "Charges"
        ],
        "summary": "Validate Charge",
        "description": "To validate a card charge",
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "type": "object",
                "example": {
                  "otp": "12345",
                  "flw_ref": "FLW-MOCK-f7a221903f699288569465135f357022"
                }
              }
            }
          }
        },
        "parameters": [
          {
            "name": "Content-Type",
            "in": "header",
            "schema": {
              "type": "string"
            },
            "example": "application/json"
          }
        ],
        "responses": {
          "200": {
            "description": "Successful response",
            "content": {
              "application/json": {
                "example": {
                  "status": "success",
                  "message": "Charge validated",
                  "data": {
                    "id": 4981392,
                    "tx_ref": "MC-3243ff00440011pu00",
                    "flw_ref": "FLW-MOCK-f7a221903f699288569465135f357022",
                    "device_fingerprint": "N/A",
                    "amount": 100,
                    "charged_amount": 100,
                    "app_fee": 1.4,
                    "merchant_fee": 0,
                    "processor_response": "successful",
                    "auth_model": "PIN",
                    "currency": "NGN",
                    "ip": "52.209.154.143",
                    "narration": "CARD Transaction ",
                    "status": "successful",
                    "auth_url": "N/A",
                    "payment_type": "card",
                    "plan": null,
                    "fraud_status": "ok",
                    "charge_type": "normal",
                    "created_at": "2024-03-21T22:16:28.000Z",
                    "account_id": 20937,
                    "customer": {
                      "id": 2376560,
                      "phone_number": null,
                      "name": "John Doe",
                      "email": "Johndoe@gmail.com",
                      "created_at": "2024-03-21T22:16:28.000Z"
                    },
                    "card": {
                      "first_6digits": "539983",
                      "last_4digits": "8381",
                      "issuer": "MASTERCARD GUARANTY TRUST BANK Mastercard Naira Debit Card",
                      "country": "NG",
                      "type": "MASTERCARD",
                      "expiry": "10/31"
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "Validation error — a required parameter is missing or invalid.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "status": "error",
                  "message": "Cardno is required",
                  "data": null
                }
              }
            }
          },
          "401": {
            "description": "Authorization error — secret key missing or incorrect.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "status": "error",
                  "message": "Authorization required",
                  "data": null
                }
              }
            }
          },
          "429": {
            "description": "Rate limit exceeded — wait and retry, increasing the wait after each retry (exponential backoff).",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "status": "error",
                  "message": "Too many requests",
                  "data": null
                }
              }
            }
          },
          "500": {
            "description": "Server error — retry after a while or contact support with the error_id.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "error_id": "ERRNO796977608T1620310828419",
                  "message": "Application error. Please contact support",
                  "code": "app_error"
                }
              }
            }
          }
        }
      }
    },
    "/v3/tokenized-charges": {
      "post": {
        "tags": [
          "Tokenized Charges"
        ],
        "summary": "Create a Tokenized Charge",
        "description": "Initiate a card payment using a tokenized customer's card",
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "type": "object",
                "example": {
                  "token": "flw-t1nf-c25d14a3a6b5afaf8022fe88212a3eaa-k3n",
                  "currency": "NGN",
                  "amount": 100,
                  "email": "Johndoe@gmail.com",
                  "tx_ref": "YOUR_UNIQUE_REFERENCE"
                }
              }
            }
          }
        },
        "parameters": [
          {
            "name": "Content-Type",
            "in": "header",
            "schema": {
              "type": "string"
            },
            "example": "application/json"
          },
          {
            "name": "",
            "in": "header",
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Successful response",
            "content": {
              "application/json": {
                "example": {
                  "status": "success",
                  "message": "Charge successful",
                  "data": {
                    "id": 1163077,
                    "tx_ref": "akhlm-pstmn-23452",
                    "flw_ref": "FLW-M03K-781621ccfe976c03515bcd07a39f3db8",
                    "redirect_url": "http://127.0.0",
                    "device_fingerprint": "N/A",
                    "amount": 30300,
                    "charged_amount": 30300,
                    "app_fee": 11741.9,
                    "merchant_fee": 0,
                    "processor_response": "Approved",
                    "auth_model": "noauth",
                    "currency": "NGN",
                    "ip": "pstmn",
                    "narration": "pstmn charge",
                    "status": "successful",
                    "payment_type": "card",
                    "created_at": "2020-03-11T19:33:20.000Z",
                    "account_id": 73362,
                    "customer": {
                      "id": 252759,
                      "phone_number": "0813XXXXXXX",
                      "name": "Kendrick Graham",
                      "email": "user@example.com",
                      "created_at": "2020-01-15T13:26:24.000Z"
                    },
                    "card": {
                      "first_6digits": "553188",
                      "last_4digits": "2950",
                      "issuer": "MASTERCARD  CREDIT",
                      "country": "NG",
                      "type": "MASTERCARD",
                      "expiry": "09/22",
                      "token": "flw-t0-d0185c6edad078c9e8304c4f78b8cd5b-m03k"
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "Validation error — a required parameter is missing or invalid.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "status": "error",
                  "message": "Cardno is required",
                  "data": null
                }
              }
            }
          },
          "401": {
            "description": "Authorization error — secret key missing or incorrect.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "status": "error",
                  "message": "Authorization required",
                  "data": null
                }
              }
            }
          },
          "429": {
            "description": "Rate limit exceeded — wait and retry, increasing the wait after each retry (exponential backoff).",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "status": "error",
                  "message": "Too many requests",
                  "data": null
                }
              }
            }
          },
          "500": {
            "description": "Server error — retry after a while or contact support with the error_id.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "error_id": "ERRNO796977608T1620310828419",
                  "message": "Application error. Please contact support",
                  "code": "app_error"
                }
              }
            }
          }
        }
      }
    },
    "/v3/bulk-tokenized-charges/": {
      "post": {
        "tags": [
          "Tokenized Charges"
        ],
        "summary": "Create Bulk Tokenized Charge",
        "description": "Initiate a card payment using multiple tokenized cards at once",
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "type": "object",
                "example": {
                  "title": "akhlm blk tknzd chrg pstmn tst 1",
                  "retry_strategy": {
                    "retry_interval": 120,
                    "retry_amount_variable": 60,
                    "retry_attempt_variable": 2
                  },
                  "bulk_data": [
                    {
                      "currency": "NGN",
                      "token": "flw-t1nf-f9b3bf384cd30d6fca42b6df9d27bd2f-m03k",
                      "country": "NG",
                      "amount": 3500,
                      "email": "user@example.com",
                      "first_name": "Example",
                      "last_name": "User",
                      "ip": "pstmn",
                      "tx_ref": "akhlm-pstmn-blkchrg-xy10"
                    },
                    {
                      "currency": "NGN",
                      "token": "flw-t1nf-f9b3bf384cd30d6fca42b6df9d27bd2f-m03k",
                      "country": "NG",
                      "amount": 3000,
                      "email": "user@example.com",
                      "first_name": "Jane",
                      "last_name": "Doe",
                      "ip": "pstmn",
                      "tx_ref": "akhlm-pstmn-blkchrge-xx10"
                    }
                  ]
                }
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Successful response",
            "content": {
              "application/json": {
                "example": {
                  "status": "success",
                  "message": "Bulk charge initiated",
                  "data": {
                    "id": 156,
                    "created_at": "2020-03-12T16:04:40.000Z",
                    "approver": "N/A",
                    "title": "akhlm blk tknzd chrg pstmn tst 1",
                    "total_charges": 2,
                    "pending_charges": 2,
                    "processed_charges": 0
                  }
                }
              }
            }
          },
          "400": {
            "description": "Validation error — a required parameter is missing or invalid.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "status": "error",
                  "message": "Cardno is required",
                  "data": null
                }
              }
            }
          },
          "401": {
            "description": "Authorization error — secret key missing or incorrect.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "status": "error",
                  "message": "Authorization required",
                  "data": null
                }
              }
            }
          },
          "429": {
            "description": "Rate limit exceeded — wait and retry, increasing the wait after each retry (exponential backoff).",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "status": "error",
                  "message": "Too many requests",
                  "data": null
                }
              }
            }
          },
          "500": {
            "description": "Server error — retry after a while or contact support with the error_id.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "error_id": "ERRNO796977608T1620310828419",
                  "message": "Application error. Please contact support",
                  "code": "app_error"
                }
              }
            }
          }
        }
      }
    },
    "/v3/bulk-tokenized-charges/:bulk_id/transactions": {
      "get": {
        "tags": [
          "Tokenized Charges"
        ],
        "summary": "Get Bulk Tokenized Transactions",
        "description": "Fetch a bulk tokenized charge",
        "parameters": [
          {
            "name": "",
            "in": "header",
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Successful response",
            "content": {
              "application/json": {
                "example": {
                  "status": "success",
                  "message": "Bulk charge transactions fetched",
                  "data": [
                    {
                      "tx_ref": "akhlm-pstmn-blkchrg-xx6",
                      "id": "1017000",
                      "flw_ref": "FLW-M03K-7544dc8d157ca763bbcf864a24906f93",
                      "device_fingerprint": "N/A",
                      "amount": 3500,
                      "currency": "NGN",
                      "charged_amount": 3549,
                      "app_fee": 49,
                      "merchant_fee": 0,
                      "processor_response": "Approved",
                      "auth_model": "noauth",
                      "ip": "pstmn",
                      "narration": "Kizito Akhilome",
                      "status": "successful",
                      "payment_type": "card",
                      "created_at": "2020-01-19T21:46:29.000Z",
                      "account_id": "73362",
                      "amount_settled": 3450,
                      "card": {
                        "expiry": "09/22",
                        "type": "MASTERCARD",
                        "country": "NIGERIA NG",
                        "issuer": "MASTERCARD  CREDIT",
                        "first_6digits": "553188",
                        "last_4digits": "2950"
                      },
                      "customer": {
                        "id": "252759",
                        "email": "user@example.com",
                        "phone_number": "0813XXXXXXX",
                        "name": "Kizito Akhilome",
                        "created_at": "2020-01-15T13:26:24.000Z"
                      }
                    },
                    {
                      "tx_ref": "akhlm-pstmn-blkchrg-xx6",
                      "id": "1017004",
                      "flw_ref": "FLW-M03K-4aa1f32bbc80a7cf9e42426e9b2d73eb",
                      "device_fingerprint": "N/A",
                      "amount": 3500,
                      "currency": "NGN",
                      "charged_amount": 3549,
                      "app_fee": 49,
                      "merchant_fee": 0,
                      "processor_response": "Approved",
                      "auth_model": "noauth",
                      "ip": "pstmn",
                      "narration": "Kizito Akhilome",
                      "status": "successful",
                      "payment_type": "card",
                      "created_at": "2020-01-19T21:49:29.000Z",
                      "account_id": "73362",
                      "amount_settled": 3450,
                      "card": {
                        "expiry": "09/22",
                        "type": "MASTERCARD",
                        "country": "NIGERIA NG",
                        "issuer": "MASTERCARD  CREDIT",
                        "first_6digits": "553188",
                        "last_4digits": "2950"
                      },
                      "customer": {
                        "id": "252759",
                        "email": "user@example.com",
                        "phone_number": "0813XXXXXXX",
                        "name": "Kizito Akhilome",
                        "created_at": "2020-01-15T13:26:24.000Z"
                      }
                    },
                    {
                      "tx_ref": "akhlm-pstmn-blkchrg-xx6",
                      "id": "1163067",
                      "flw_ref": "FLW-M03K-9d02da3020c67ac05ade7b596881d59f",
                      "device_fingerprint": "N/A",
                      "amount": 3500,
                      "currency": "NGN",
                      "charged_amount": 3500,
                      "app_fee": 1050,
                      "merchant_fee": 0,
                      "processor_response": "Approved",
                      "auth_model": "noauth",
                      "ip": "pstmn",
                      "narration": "Kizito Akhilome",
                      "status": "successful",
                      "payment_type": "card",
                      "created_at": "2020-03-11T19:22:06.000Z",
                      "account_id": "73362",
                      "amount_settled": 2450,
                      "card": {
                        "expiry": "09/22",
                        "type": "MASTERCARD",
                        "country": "NIGERIA NG",
                        "issuer": "MASTERCARD  CREDIT",
                        "first_6digits": "553188",
                        "last_4digits": "2950"
                      },
                      "customer": {
                        "id": "252759",
                        "email": "user@example.com",
                        "phone_number": "0813XXXXXXX",
                        "name": "Kendrick Graham",
                        "created_at": "2020-01-15T13:26:24.000Z"
                      }
                    },
                    {
                      "tx_ref": "akhlm-pstmn-blkchrge-xx6",
                      "id": "1017001",
                      "flw_ref": "FLW-M03K-bbd148a9569b709882da8437e123ba61",
                      "device_fingerprint": "N/A",
                      "amount": 3000,
                      "currency": "NGN",
                      "charged_amount": 3042,
                      "app_fee": 42,
                      "merchant_fee": 0,
                      "processor_response": "Approved",
                      "auth_model": "noauth",
                      "ip": "pstmn",
                      "narration": "Kizito Akhilome",
                      "status": "successful",
                      "payment_type": "card",
                      "created_at": "2020-01-19T21:46:30.000Z",
                      "account_id": "73362",
                      "amount_settled": 2950,
                      "card": {
                        "expiry": "09/22",
                        "type": "MASTERCARD",
                        "country": "NIGERIA NG",
                        "issuer": "MASTERCARD  CREDIT",
                        "first_6digits": "553188",
                        "last_4digits": "2950"
                      },
                      "customer": {
                        "id": "252759",
                        "email": "user@example.com",
                        "phone_number": "0813XXXXXXX",
                        "name": "Kizito Akhilome",
                        "created_at": "2020-01-15T13:26:24.000Z"
                      }
                    },
                    {
                      "tx_ref": "akhlm-pstmn-blkchrge-xx6",
                      "id": "1017005",
                      "flw_ref": "FLW-M03K-3a046716482046ea974c73d73eaa4463",
                      "device_fingerprint": "N/A",
                      "amount": 3000,
                      "currency": "NGN",
                      "charged_amount": 3042,
                      "app_fee": 42,
                      "merchant_fee": 0,
                      "processor_response": "Approved",
                      "auth_model": "noauth",
                      "ip": "pstmn",
                      "narration": "Kizito Akhilome",
                      "status": "successful",
                      "payment_type": "card",
                      "created_at": "2020-01-19T21:49:30.000Z",
                      "account_id": "73362",
                      "amount_settled": 2950,
                      "card": {
                        "expiry": "09/22",
                        "type": "MASTERCARD",
                        "country": "NIGERIA NG",
                        "issuer": "MASTERCARD  CREDIT",
                        "first_6digits": "553188",
                        "last_4digits": "2950"
                      },
                      "customer": {
                        "id": "252759",
                        "email": "user@example.com",
                        "phone_number": "0813XXXXXXX",
                        "name": "Kizito Akhilome",
                        "created_at": "2020-01-15T13:26:24.000Z"
                      }
                    },
                    {
                      "tx_ref": "akhlm-pstmn-blkchrge-xx6",
                      "id": "1163068",
                      "flw_ref": "FLW-M03K-02c21a8095c7e064b8b9714db834080b",
                      "device_fingerprint": "N/A",
                      "amount": 3000,
                      "currency": "NGN",
                      "charged_amount": 3000,
                      "app_fee": 1000,
                      "merchant_fee": 0,
                      "processor_response": "Approved",
                      "auth_model": "noauth",
                      "ip": "pstmn",
                      "narration": "Kizito Akhilome",
                      "status": "successful",
                      "payment_type": "card",
                      "created_at": "2020-03-11T19:22:07.000Z",
                      "account_id": "73362",
                      "amount_settled": 2000,
                      "card": {
                        "expiry": "09/22",
                        "type": "MASTERCARD",
                        "country": "NIGERIA NG",
                        "issuer": "MASTERCARD  CREDIT",
                        "first_6digits": "553188",
                        "last_4digits": "2950"
                      },
                      "customer": {
                        "id": "252759",
                        "email": "user@example.com",
                        "phone_number": "0813XXXXXXX",
                        "name": "Kendrick Graham",
                        "created_at": "2020-01-15T13:26:24.000Z"
                      }
                    }
                  ]
                }
              }
            }
          },
          "400": {
            "description": "Validation error — a required parameter is missing or invalid.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "status": "error",
                  "message": "Cardno is required",
                  "data": null
                }
              }
            }
          },
          "401": {
            "description": "Authorization error — secret key missing or incorrect.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "status": "error",
                  "message": "Authorization required",
                  "data": null
                }
              }
            }
          },
          "429": {
            "description": "Rate limit exceeded — wait and retry, increasing the wait after each retry (exponential backoff).",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "status": "error",
                  "message": "Too many requests",
                  "data": null
                }
              }
            }
          },
          "500": {
            "description": "Server error — retry after a while or contact support with the error_id.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "error_id": "ERRNO796977608T1620310828419",
                  "message": "Application error. Please contact support",
                  "code": "app_error"
                }
              }
            }
          }
        }
      }
    },
    "/v3/bulk-tokenized-charges/:bulk_id": {
      "get": {
        "tags": [
          "Tokenized Charges"
        ],
        "summary": "Get status of Bulk Tokenized Charge",
        "description": "Get bulk charge status",
        "responses": {
          "200": {
            "description": "Successful response",
            "content": {
              "application/json": {
                "example": {
                  "status": "success",
                  "message": "Bulk charge fetched",
                  "data": {
                    "id": 156,
                    "title": "akhlm blk tknzd chrg pstmn tst 1",
                    "approver": "N/A",
                    "processed_charges": 2,
                    "pending_charges": 0,
                    "total_charges": 2
                  }
                }
              }
            }
          },
          "400": {
            "description": "Validation error — a required parameter is missing or invalid.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "status": "error",
                  "message": "Cardno is required",
                  "data": null
                }
              }
            }
          },
          "401": {
            "description": "Authorization error — secret key missing or incorrect.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "status": "error",
                  "message": "Authorization required",
                  "data": null
                }
              }
            }
          },
          "429": {
            "description": "Rate limit exceeded — wait and retry, increasing the wait after each retry (exponential backoff).",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "status": "error",
                  "message": "Too many requests",
                  "data": null
                }
              }
            }
          },
          "500": {
            "description": "Server error — retry after a while or contact support with the error_id.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "error_id": "ERRNO796977608T1620310828419",
                  "message": "Application error. Please contact support",
                  "code": "app_error"
                }
              }
            }
          }
        }
      }
    },
    "/v3/tokens/:token": {
      "put": {
        "tags": [
          "Tokenized Charges"
        ],
        "summary": "Update a Card Token",
        "description": "Update Token Details",
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "type": "object",
                "example": {
                  "email": "user@example.com",
                  "full_name": "Kendrick Graham",
                  "phone_number": "0813XXXXXXX"
                }
              }
            }
          }
        },
        "parameters": [
          {
            "name": "Content-Type",
            "in": "header",
            "schema": {
              "type": "string"
            },
            "example": "application/json"
          }
        ],
        "responses": {
          "200": {
            "description": "Successful response",
            "content": {
              "application/json": {
                "example": {
                  "status": "success",
                  "message": "Token details updated",
                  "data": {
                    "customer_email": "user@example.com",
                    "customer_full_name": "Kendrick Graham",
                    "customer_phone_number": "0813XXXXXXX",
                    "created_at": "2020-01-15T13:26:24.000Z"
                  }
                }
              }
            }
          },
          "400": {
            "description": "Validation error — a required parameter is missing or invalid.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "status": "error",
                  "message": "Cardno is required",
                  "data": null
                }
              }
            }
          },
          "401": {
            "description": "Authorization error — secret key missing or incorrect.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "status": "error",
                  "message": "Authorization required",
                  "data": null
                }
              }
            }
          },
          "429": {
            "description": "Rate limit exceeded — wait and retry, increasing the wait after each retry (exponential backoff).",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "status": "error",
                  "message": "Too many requests",
                  "data": null
                }
              }
            }
          },
          "500": {
            "description": "Server error — retry after a while or contact support with the error_id.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "error_id": "ERRNO796977608T1620310828419",
                  "message": "Application error. Please contact support",
                  "code": "app_error"
                }
              }
            }
          }
        }
      }
    },
    "/v3/charges/:flw_ref/capture": {
      "post": {
        "tags": [
          "Preauthorization"
        ],
        "summary": "Capture a Charge",
        "description": "Capture the payment of an existing but uncaptured preauth charge.",
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "type": "object",
                "example": {
                  "amount": 100
                }
              }
            }
          }
        },
        "parameters": [
          {
            "name": "Content-Type",
            "in": "header",
            "schema": {
              "type": "string"
            },
            "example": "application/json"
          }
        ],
        "responses": {
          "200": {
            "description": "Successful response",
            "content": {
              "application/json": {
                "example": {
                  "status": "success",
                  "message": "Charge captured",
                  "data": {
                    "id": 4973327,
                    "tx_ref": "YOUR_UNIQUE_REFERENCE",
                    "flw_ref": "FLW-MOCK-PREAUTH-1c4b0406fccc0fad316b46f947e870e9",
                    "device_fingerprint": "N/A",
                    "amount": 100,
                    "charged_amount": 100,
                    "app_fee": 5.8,
                    "merchant_fee": 0,
                    "processor_response": "Approved",
                    "auth_model": "NOAUTH",
                    "currency": "NGN",
                    "ip": "52.209.154.143",
                    "narration": "FLW-PBF CARD Transaction ",
                    "status": "successful",
                    "auth_url": "N/A",
                    "payment_type": "card",
                    "plan": null,
                    "fraud_status": "ok",
                    "charge_type": "preauth",
                    "created_at": "2024-03-18T10:04:04.000Z",
                    "account_id": 20937,
                    "customer": {
                      "id": 2373843,
                      "phone_number": null,
                      "name": "Anonymous customer",
                      "email": "developers@flutterwavego.com",
                      "created_at": "2024-03-18T10:04:03.000Z"
                    },
                    "card": {
                      "first_6digits": "537728",
                      "last_4digits": "7450",
                      "issuer": "MASTERCARD JSB PROBUSINESSBANK CREDITGOLD",
                      "country": "RU",
                      "type": "MASTERCARD",
                      "expiry": "09/31"
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "Validation error — a required parameter is missing or invalid.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "status": "error",
                  "message": "Cardno is required",
                  "data": null
                }
              }
            }
          },
          "401": {
            "description": "Authorization error — secret key missing or incorrect.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "status": "error",
                  "message": "Authorization required",
                  "data": null
                }
              }
            }
          },
          "429": {
            "description": "Rate limit exceeded — wait and retry, increasing the wait after each retry (exponential backoff).",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "status": "error",
                  "message": "Too many requests",
                  "data": null
                }
              }
            }
          },
          "500": {
            "description": "Server error — retry after a while or contact support with the error_id.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "error_id": "ERRNO796977608T1620310828419",
                  "message": "Application error. Please contact support",
                  "code": "app_error"
                }
              }
            }
          }
        }
      }
    },
    "/v3/charges/:flw_ref/refund": {
      "post": {
        "tags": [
          "Preauthorization"
        ],
        "summary": "Create a Refund",
        "description": "Partially or fully initiate a refund on a preauth charge",
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "type": "object",
                "example": {
                  "amount": "100"
                }
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Successful response",
            "content": {
              "application/json": {
                "example": {
                  "status": "success",
                  "message": "Charge refunded",
                  "data": {
                    "id": 4973363,
                    "tx_ref": "YOUR_UNIQUE_REFERENCE",
                    "flw_ref": "FLW-MOCK-PREAUTH-bde14443c3f233d11c5f574acc120399",
                    "device_fingerprint": "N/A",
                    "amount": 100,
                    "charged_amount": 100,
                    "app_fee": 5.8,
                    "merchant_fee": 0,
                    "processor_response": "Approved",
                    "auth_model": "NOAUTH",
                    "currency": "NGN",
                    "ip": "54.75.161.64",
                    "narration": "FLW-PBF CARD Transaction ",
                    "status": "successful",
                    "auth_url": "N/A",
                    "payment_type": "card",
                    "plan": null,
                    "fraud_status": "ok",
                    "charge_type": "preauth",
                    "created_at": "2024-03-18T10:18:56.000Z",
                    "account_id": 20937,
                    "customer": {
                      "id": 2373852,
                      "phone": null,
                      "fullName": "Anonymous customer",
                      "customertoken": null,
                      "email": "developers@flutterwavego.com",
                      "createdAt": "2024-03-18T10:18:56.000Z",
                      "updatedAt": "2024-03-18T10:18:56.000Z",
                      "deletedAt": null,
                      "AccountId": 20937
                    },
                    "card": {
                      "first_6digits": "537728",
                      "last_4digits": "7450",
                      "issuer": "MASTERCARD JSB PROBUSINESSBANK CREDITGOLD",
                      "country": "RU",
                      "type": "MASTERCARD",
                      "expiry": "09/31"
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "Validation error — a required parameter is missing or invalid.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "status": "error",
                  "message": "Cardno is required",
                  "data": null
                }
              }
            }
          },
          "401": {
            "description": "Authorization error — secret key missing or incorrect.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "status": "error",
                  "message": "Authorization required",
                  "data": null
                }
              }
            }
          },
          "429": {
            "description": "Rate limit exceeded — wait and retry, increasing the wait after each retry (exponential backoff).",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "status": "error",
                  "message": "Too many requests",
                  "data": null
                }
              }
            }
          },
          "500": {
            "description": "Server error — retry after a while or contact support with the error_id.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "error_id": "ERRNO796977608T1620310828419",
                  "message": "Application error. Please contact support",
                  "code": "app_error"
                }
              }
            }
          }
        }
      }
    },
    "/v3/charges/:flw_ref/void": {
      "post": {
        "tags": [
          "Preauthorization"
        ],
        "summary": "Void a Charge",
        "description": "Void the payment of a previously captured preauth charge",
        "requestBody": {
          "content": {}
        },
        "parameters": [
          {
            "name": "Content-Type",
            "in": "header",
            "schema": {
              "type": "string"
            },
            "example": "application/json"
          }
        ],
        "responses": {
          "200": {
            "description": "Successful response",
            "content": {
              "application/json": {
                "example": {
                  "status": "success",
                  "message": "Charge voided",
                  "data": {
                    "id": 4973327,
                    "tx_ref": "YOUR_UNIQUE_REFERENCE",
                    "flw_ref": "FLW-MOCK-PREAUTH-1c4b0406fccc0fad316b46f947e870e9",
                    "device_fingerprint": "N/A",
                    "amount": 100,
                    "charged_amount": 100,
                    "app_fee": 5.8,
                    "merchant_fee": 0,
                    "processor_response": "Approved",
                    "auth_model": "NOAUTH",
                    "currency": "NGN",
                    "ip": "52.209.154.143",
                    "narration": "FLW-PBF CARD Transaction ",
                    "status": "voided",
                    "auth_url": "N/A",
                    "payment_type": "card",
                    "plan": null,
                    "fraud_status": "ok",
                    "charge_type": "preauth",
                    "created_at": "2024-03-18T10:04:04.000Z",
                    "account_id": 20937,
                    "customer": {
                      "id": 2373843,
                      "phone_number": null,
                      "name": "Anonymous customer",
                      "email": "developers@flutterwavego.com",
                      "created_at": "2024-03-18T10:04:03.000Z"
                    },
                    "card": {
                      "first_6digits": "537728",
                      "last_4digits": "7450",
                      "issuer": "MASTERCARD JSB PROBUSINESSBANK CREDITGOLD",
                      "country": "RU",
                      "type": "MASTERCARD",
                      "expiry": "09/31"
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "Validation error — a required parameter is missing or invalid.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "status": "error",
                  "message": "Cardno is required",
                  "data": null
                }
              }
            }
          },
          "401": {
            "description": "Authorization error — secret key missing or incorrect.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "status": "error",
                  "message": "Authorization required",
                  "data": null
                }
              }
            }
          },
          "429": {
            "description": "Rate limit exceeded — wait and retry, increasing the wait after each retry (exponential backoff).",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "status": "error",
                  "message": "Too many requests",
                  "data": null
                }
              }
            }
          },
          "500": {
            "description": "Server error — retry after a while or contact support with the error_id.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "error_id": "ERRNO796977608T1620310828419",
                  "message": "Application error. Please contact support",
                  "code": "app_error"
                }
              }
            }
          }
        }
      }
    },
    "/v3/transactions/:id/verify": {
      "get": {
        "tags": [
          "Transactions"
        ],
        "summary": "Verify a Transaction",
        "description": "Verify transactions using the transaction id",
        "parameters": [
          {
            "name": "Content-Type",
            "in": "header",
            "schema": {
              "type": "string"
            },
            "example": "application/json"
          }
        ],
        "responses": {
          "200": {
            "description": "Successful response",
            "content": {
              "application/json": {
                "example": {
                  "status": "success",
                  "message": "Transaction fetched successfully",
                  "data": {
                    "id": 4975363,
                    "tx_ref": "1710840858755-RND_83",
                    "flw_ref": "0537565244201710840859363",
                    "device_fingerprint": "N/A",
                    "amount": 1000,
                    "currency": "NGN",
                    "charged_amount": 1000,
                    "app_fee": 14,
                    "merchant_fee": 0,
                    "processor_response": "success",
                    "auth_model": "AUTH",
                    "ip": "::ffff:172.16.47.200",
                    "narration": "FLUTTERWAVE V3 DOCS",
                    "status": "successful",
                    "payment_type": "bank_transfer",
                    "created_at": "2024-03-19T09:34:27.000Z",
                    "account_id": 118468,
                    "meta": {
                      "originatoraccountnumber": "123*******90",
                      "originatorname": "JOHN DOE",
                      "bankname": "Access Bank",
                      "originatoramount": "N/A"
                    },
                    "amount_settled": 986,
                    "customer": {
                      "id": 2374551,
                      "name": "Anonymous customer",
                      "phone_number": "08012345678",
                      "email": "Johndoe@gmail.com",
                      "created_at": "2024-03-19T09:34:18.000Z"
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "Validation error — a required parameter is missing or invalid.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "status": "error",
                  "message": "Cardno is required",
                  "data": null
                }
              }
            }
          },
          "401": {
            "description": "Authorization error — secret key missing or incorrect.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "status": "error",
                  "message": "Authorization required",
                  "data": null
                }
              }
            }
          },
          "429": {
            "description": "Rate limit exceeded — wait and retry, increasing the wait after each retry (exponential backoff).",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "status": "error",
                  "message": "Too many requests",
                  "data": null
                }
              }
            }
          },
          "500": {
            "description": "Server error — retry after a while or contact support with the error_id.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "error_id": "ERRNO796977608T1620310828419",
                  "message": "Application error. Please contact support",
                  "code": "app_error"
                }
              }
            }
          }
        }
      }
    },
    "/v3/transactions/verify_by_reference": {
      "get": {
        "tags": [
          "Transactions"
        ],
        "summary": "Verify a transaction by Transaction reference",
        "description": "Verify transactions using the transaction reference (tx_ref)",
        "parameters": [
          {
            "name": "Content-Type",
            "in": "header",
            "schema": {
              "type": "string"
            },
            "example": "application/json"
          },
          {
            "name": "tx_ref",
            "in": "query",
            "schema": {
              "type": "string"
            },
            "example": "1710840858755-RND_83"
          }
        ],
        "responses": {
          "200": {
            "description": "Successful response",
            "content": {
              "application/json": {
                "example": {
                  "status": "success",
                  "message": "Transaction fetched successfully",
                  "data": {
                    "id": 4975363,
                    "tx_ref": "1710840858755-RND_83",
                    "flw_ref": "0537565244201710840859363",
                    "device_fingerprint": "N/A",
                    "amount": 1000,
                    "currency": "NGN",
                    "charged_amount": 1000,
                    "app_fee": 14,
                    "merchant_fee": 0,
                    "processor_response": "success",
                    "auth_model": "AUTH",
                    "ip": "::ffff:172.16.47.200",
                    "narration": "FLUTTERWAVE V3 DOCS",
                    "status": "successful",
                    "payment_type": "bank_transfer",
                    "created_at": "2024-03-19T09:34:27.000Z",
                    "account_id": 118468,
                    "meta": {
                      "originatoraccountnumber": "123*******90",
                      "originatorname": "JOHN DOE",
                      "bankname": "Access Bank",
                      "originatoramount": "N/A"
                    },
                    "amount_settled": 986,
                    "customer": {
                      "id": 2374551,
                      "name": "Anonymous customer",
                      "phone_number": "08012345678",
                      "email": "Johndoe@gmail.com",
                      "created_at": "2024-03-19T09:34:18.000Z"
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "Validation error — a required parameter is missing or invalid.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
                      "type": "string"
                    },
                    "data": {
                      "type": "object",
                      "nullable": true,
                      "example": null
                    },
                    "code": {
                      "type": "string",
                      "example": "app_error",
                      "description": "Present on server errors."
                    },
                    "error_id": {
                      "type": "string",
                      "description": "Support reference for server errors."
                    }
                  }
                },
                "example": {
                  "status": "error",
                  "message": "Cardno is required",
                  "data": null
                }
              }
            }
          },
          "401": {
            "description": "Authorization error — secret key missing or incorrect.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "error"
                    },
                    "message": {
[...]
